/*===========================================================================*/
/*   (Jvm/tail.scm)                                                          */
/*   Bigloo (2.6b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon Dec 15 12:14:36 CET 2003        */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc-2.95 -lib-dir /users/serrano/prgm/project/bigloo/lib/2.6b -unsafev -no-hello -O2 -rm -unsafe -s -indent Jvm/tail.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>


/* Object type definitions */
typedef struct BgL_typez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   obj_t BgL_siza7eza7;
   obj_t BgL_classz00;
   obj_t BgL_coercezd2tozd2;
   obj_t BgL_parentsz00;
   bool_t BgL_initzf3zf3;
   bool_t BgL_magiczf3zf3;
   obj_t BgL_z42z42;
   obj_t BgL_aliasz00;
   obj_t BgL_pointedzd2tozd2byz00;
   obj_t BgL_tvectorz00;
   obj_t BgL_locationz00;
   obj_t BgL_importzd2locationzd2;
} *BgL_typez00_bglt;

typedef struct BgL_valuez00_bgl {
   header_t header;
   obj_t widening;
} *BgL_valuez00_bglt;

typedef struct BgL_variablez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
} *BgL_variablez00_bglt;

typedef struct BgL_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   obj_t BgL_modulez00;
   obj_t BgL_importz00;
   bool_t BgL_evaluablezf3zf3;
   bool_t BgL_libraryzf3zf3;
   bool_t BgL_userzf3zf3;
   obj_t BgL_pragmaz00;
   obj_t BgL_srcz00;
   obj_t BgL_jvmzd2typezd2namez00;
} *BgL_globalz00_bglt;

typedef struct BgL_localz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   bool_t BgL_userzf3zf3;
   long BgL_keyz00;
} *BgL_localz00_bglt;

typedef struct BgL_funz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_effectz00;
} *BgL_funz00_bglt;

typedef struct BgL_sfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_effectz00;
   obj_t BgL_propertyz00;
   obj_t BgL_argsz00;
   obj_t BgL_bodyz00;
   obj_t BgL_classz00;
   obj_t BgL_dssslzd2keywordszd2;
   obj_t BgL_locz00;
} *BgL_sfunz00_bglt;

typedef struct BgL_cfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_effectz00;
   obj_t BgL_argszd2typezd2;
   bool_t BgL_macrozf3zf3;
   bool_t BgL_infixzf3zf3;
   obj_t BgL_methodz00;
} *BgL_cfunz00_bglt;

typedef struct BgL_svarz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
} *BgL_svarz00_bglt;

typedef struct BgL_scnstz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_nodez00;
   obj_t BgL_classz00;
   obj_t BgL_locz00;
} *BgL_scnstz00_bglt;

typedef struct BgL_cvarz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_macrozf3zf3;
} *BgL_cvarz00_bglt;

typedef struct BgL_sexitz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_handlerz00;
   bool_t BgL_detachedzf3zf3;
} *BgL_sexitz00_bglt;

typedef struct BgL_feffectz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_readz00;
   obj_t BgL_writez00;
} *BgL_feffectz00_bglt;

typedef struct BgL_nodez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
} *BgL_nodez00_bglt;

typedef struct BgL_nodezf2effectzf2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
} *BgL_nodezf2effectzf2_bglt;

typedef struct BgL_atomz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_atomz00_bglt;

typedef struct BgL_varz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_varz00_bglt;

typedef struct BgL_closurez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_closurez00_bglt;

typedef struct BgL_kwotez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_kwotez00_bglt;

typedef struct BgL_sequencez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_nodesz00;
} *BgL_sequencez00_bglt;

typedef struct BgL_appz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
} *BgL_appz00_bglt;

typedef struct BgL_appzd2lyzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_appzd2lyzd2_bglt;

typedef struct BgL_funcallz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
   obj_t BgL_strengthz00;
} *BgL_funcallz00_bglt;

typedef struct BgL_externz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
} *BgL_externz00_bglt;

typedef struct BgL_pragmaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_formatz00;
} *BgL_pragmaz00_bglt;

typedef struct BgL_getfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_getfieldz00_bglt;

typedef struct BgL_setfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_setfieldz00_bglt;

typedef struct BgL_newz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
} *BgL_newz00_bglt;

typedef struct BgL_vallocz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_czd2heapzd2formatz00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_vallocz00_bglt;

typedef struct BgL_vrefz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vrefz00_bglt;

typedef struct BgL_vsetz12z12_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vsetz12z12_bglt;

typedef struct BgL_vlengthz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vlengthz00_bglt;

typedef struct BgL_isaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   struct BgL_typez00_bgl * BgL_classz00;
} *BgL_isaz00_bglt;

typedef struct BgL_castz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_castz00_bglt;

typedef struct BgL_setqz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_setqz00_bglt;

typedef struct BgL_conditionalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   struct BgL_nodez00_bgl * BgL_truez00;
   struct BgL_nodez00_bgl * BgL_falsez00;
} *BgL_conditionalz00_bglt;

typedef struct BgL_failz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_procz00;
   struct BgL_nodez00_bgl * BgL_msgz00;
   struct BgL_nodez00_bgl * BgL_objz00;
} *BgL_failz00_bglt;

typedef struct BgL_selectz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   obj_t BgL_clausesz00;
   struct BgL_typez00_bgl * BgL_itemzd2typezd2;
} *BgL_selectz00_bglt;

typedef struct BgL_letzd2funzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_localsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_letzd2funzd2_bglt;

typedef struct BgL_letzd2varzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_bindingsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
   bool_t BgL_removablezf3zf3;
} *BgL_letzd2varzd2_bglt;

typedef struct BgL_setzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_setzd2exzd2itz00_bglt;

typedef struct BgL_jumpzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_exitz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_jumpzd2exzd2itz00_bglt;

typedef struct BgL_makezd2boxzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_makezd2boxzd2_bglt;

typedef struct BgL_boxzd2refzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_varz00;
} *BgL_boxzd2refzd2_bglt;

typedef struct BgL_boxzd2setz12zc0_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_boxzd2setz12zc0_bglt;

typedef struct BgL_tclassz00_bgl {
   obj_t BgL_itszd2superzd2;
   obj_t BgL_slotsz00;
   struct BgL_globalz00_bgl * BgL_holderz00;
   obj_t BgL_wideningz00;
   long BgL_depthz00;
   bool_t BgL_finalzf3zf3;
   obj_t BgL_constructorz00;
   obj_t BgL_virtualzd2slotszd2numberz00;
   bool_t BgL_abstractzf3zf3;
   obj_t BgL_widezd2typezd2;
} *BgL_tclassz00_bglt;

typedef struct BgL_jclassz00_bgl {
   obj_t BgL_itszd2superzd2;
   obj_t BgL_slotsz00;
   obj_t BgL_packagez00;
} *BgL_jclassz00_bglt;

typedef struct BgL_wclassz00_bgl {
   obj_t BgL_itszd2classzd2;
} *BgL_wclassz00_bglt;

typedef struct BgL_envz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_declarationsz00;
   obj_t BgL_declaredtypez00;
   obj_t BgL_declaredclassz00;
   obj_t BgL_declaredmodulez00;
   obj_t BgL_currentzd2modulezd2;
   obj_t BgL_declaredfieldsz00;
   obj_t BgL_declaredglobalz00;
   obj_t BgL_libdeclaredz00;
   obj_t BgL_proceduresz00;
   obj_t BgL_clinitzd2codezd2;
   obj_t BgL_currentzd2methodzd2;
   obj_t BgL_vcountz00;
   obj_t BgL_localsz00;
   obj_t BgL_freelocalsz00;
   obj_t BgL_maplocalsz00;
   obj_t BgL_stackz00;
   obj_t BgL_codez00;
} *BgL_envz00_bglt;


extern obj_t BGl_compilerzd2ifzd2zzjvm_compilerz00(BgL_conditionalz00_bglt, BgL_envz00_bglt, obj_t);
extern obj_t BGl_vrefz00zzast_nodez00;
extern obj_t BGl_compilerzd2boxzd2refz00zzjvm_compilerz00(BgL_boxzd2refzd2_bglt, BgL_envz00_bglt);
static obj_t BGl_compilezd2tailzd2vref3060z00zzjvm_tailz00(obj_t, obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zzjvm_tailz00();
static obj_t BGl_compilezd2tailzd2jumpzd2exzd2it3072z00zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_compilerzd2boxzd2setz12z12zzjvm_compilerz00(BgL_boxzd2setz12zc0_bglt, BgL_envz00_bglt);
static obj_t BGl_compilezd2tailzd2setq3034z00zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_compilerzd2funcallzd2zzjvm_compilerz00(BgL_funcallz00_bglt, BgL_envz00_bglt);
BGL_IMPORT obj_t open_input_string(obj_t);
static obj_t BGl_compilezd2tailzd2boxzd2setz123080zc0zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_letzd2funzd2zzast_nodez00;
static obj_t BGl_compilezd2tailzd2new3056z00zzjvm_tailz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t);
extern obj_t BGl_compilerzd2labelszd2zzjvm_compilerz00(BgL_letzd2funzd2_bglt, BgL_envz00_bglt, obj_t);
extern obj_t BGl_compilerzd2getfieldzd2zzjvm_compilerz00(BgL_getfieldz00_bglt, BgL_envz00_bglt);
BGL_EXPORTED_DECL obj_t BGl_compilezd2tailzd2zzjvm_tailz00(BgL_nodez00_bglt, BgL_envz00_bglt);
extern obj_t BGl_compilerzd2pragmazd2zzjvm_compilerz00(BgL_pragmaz00_bglt, BgL_envz00_bglt);
BGL_IMPORT obj_t BGl_addzd2genericz12zc0zz__objectz00(obj_t, obj_t);
extern obj_t BGl_compilerzd2makezd2boxz00zzjvm_compilerz00(BgL_makezd2boxzd2_bglt, BgL_envz00_bglt);
extern obj_t BGl_letzd2varzd2zzast_nodez00;
extern obj_t BGl_pragmaz00zzast_nodez00;
extern obj_t BGl_compilezd2typezd2zzjvm_envz00(obj_t, BgL_envz00_bglt);
extern obj_t BGl_compilerzd2failzd2zzjvm_compilerz00(BgL_failz00_bglt, BgL_envz00_bglt);
extern obj_t BGl_compilerzd2atomzd2zzjvm_compilerz00(obj_t, BgL_envz00_bglt);
static obj_t BGl_compilezd2tailzd2atom3028z00zzjvm_tailz00(obj_t, obj_t, obj_t);
static obj_t BGl__compilezd2tail3726zd2zzjvm_tailz00(obj_t, obj_t, obj_t);
static obj_t BGl_compilezd2tailzd2var3030z00zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_compilerzd2castzd2zzjvm_compilerz00(BgL_castz00_bglt, BgL_envz00_bglt, obj_t);
extern obj_t BGl_castz00zzast_nodez00;
extern obj_t BGl_boxzd2refzd2zzast_nodez00;
extern obj_t BGl_varz00zzast_nodez00;
static obj_t BGl_cnstzd2initzd2zzjvm_tailz00();
extern obj_t BGl_atomz00zzast_nodez00;
extern obj_t BGl_failz00zzast_nodez00;
extern obj_t BGl_funcallz00zzast_nodez00;
extern obj_t BGl_simplezd2typezd2zzjvm_instrz00(obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zzjvm_tailz00();
static obj_t BGl_compilezd2tailzd2boxzd2ref3078zd2zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_makezd2boxzd2zzast_nodez00;
static obj_t BGl_compilezd2tailzd2getfield3052z00zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_getfieldz00zzast_nodez00;
extern obj_t BGl_isaz00zzast_nodez00;
extern obj_t BGl_compilerzd2vsetzd2zzjvm_compilerz00(BgL_vsetz12z12_bglt, BgL_envz00_bglt);
BGL_IMPORT obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
static obj_t BGl_compilezd2tailzd2valloc3058z00zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_compilerzd2selectzd2zzjvm_compilerz00(BgL_selectz00_bglt, BgL_envz00_bglt, obj_t);
extern obj_t BGl_compilerzd2valloczd2zzjvm_compilerz00(BgL_vallocz00_bglt, BgL_envz00_bglt);
extern obj_t BGl_selectz00zzast_nodez00;
extern obj_t BGl__storez00zzjvm_instrz00(BgL_envz00_bglt, BgL_localz00_bglt);
extern obj_t BGl_vallocz00zzast_nodez00;
static obj_t BGl_toplevelzd2initzd2zzjvm_tailz00();
extern obj_t BGl_appzd2lyzd2zzast_nodez00;
static obj_t BGl_compilezd2tailzd2fail3074z00zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzjvm_tailz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_envz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_instrz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_exprz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_compilerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
static obj_t BGl_compilezd2tailzd2isa3066z00zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_compilerzd2appzd2zzjvm_compilerz00(BgL_appz00_bglt, BgL_envz00_bglt);
static obj_t BGl_compilezd2tailzd2setzd2exzd2it3070z00zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_compilerzd2vrefzd2zzjvm_compilerz00(BgL_vrefz00_bglt, BgL_envz00_bglt);
extern obj_t BGl_compilerzd2vlengthzd2zzjvm_compilerz00(BgL_vlengthz00_bglt, BgL_envz00_bglt);
extern obj_t BGl_compilerzd2setqzd2zzjvm_compilerz00(BgL_setqz00_bglt, BgL_envz00_bglt);
extern obj_t BGl_compilerzd2newzd2zzjvm_compilerz00(BgL_newz00_bglt, BgL_envz00_bglt);
BGL_IMPORT obj_t bgl_reverse(obj_t);
static obj_t BGl_compilezd2tailzd2makezd2box3076zd2zzjvm_tailz00(obj_t, obj_t, obj_t);
static obj_t BGl_compilezd2tailzd2vlength3064z00zzjvm_tailz00(obj_t, obj_t, obj_t);
static obj_t BGl__compilezd2tailzd2default3025z00zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
extern obj_t BGl_compilerzd2applyzd2zzjvm_compilerz00(BgL_appzd2lyzd2_bglt, BgL_envz00_bglt);
static obj_t BGl_compilezd2tailzd2appzd2ly3046zd2zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_compilerzd2jumpzd2exitz00zzjvm_compilerz00(BgL_jumpzd2exzd2itz00_bglt, BgL_envz00_bglt);
extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
extern obj_t BGl_compilerzd2setfieldzd2zzjvm_compilerz00(BgL_setfieldz00_bglt, BgL_envz00_bglt);
extern obj_t BGl_newz00zzast_nodez00;
static obj_t BGl_compilezd2tailzd2app3044z00zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_conditionalz00zzast_nodez00;
extern obj_t BGl_sequencez00zzast_nodez00;
extern obj_t BGl__getstaticz00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
extern obj_t BGl_compilerzd2letzd2zzjvm_compilerz00(BgL_letzd2varzd2_bglt, BgL_envz00_bglt, obj_t);
static obj_t BGl_compilezd2tailzd2conditional3038z00zzjvm_tailz00(obj_t, obj_t, obj_t);
static obj_t BGl_compilezd2tailzd2vsetz123062z12zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_appz00zzast_nodez00;
static obj_t BGl_compilezd2tailzd2cast3068z00zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_compilerzd2sequencezd2zzjvm_compilerz00(BgL_sequencez00_bglt, BgL_envz00_bglt, obj_t);
static obj_t BGl_compilezd2tailzd2letzd2var3032zd2zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_vlengthz00zzast_nodez00;
static obj_t BGl_compilezd2tailzd2funcall3048z00zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_setfieldz00zzast_nodez00;
static obj_t BGl_compilezd2tailzd2pragma3050z00zzjvm_tailz00(obj_t, obj_t, obj_t);
extern obj_t BGl_compilerzd2isazd2zzjvm_compilerz00(BgL_isaz00_bglt, BgL_envz00_bglt);
extern obj_t BGl_compilerzd2setexitzd2zzjvm_compilerz00(BgL_setzd2exzd2itz00_bglt, BgL_envz00_bglt, obj_t);
static obj_t BGl_compilezd2tailzd2select3040z00zzjvm_tailz00(obj_t, obj_t, obj_t);
static obj_t BGl_compilezd2tailzd2letzd2fun3042zd2zzjvm_tailz00(obj_t, obj_t, obj_t);
static obj_t BGl_compilezd2tailzd2setfield3054z00zzjvm_tailz00(obj_t, obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zzjvm_tailz00 = BUNSPEC;
extern obj_t BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_bglt, obj_t);
extern obj_t BGl__gotoz00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
extern obj_t BGl_compilezd2exprzd2zzjvm_exprz00(BgL_nodez00_bglt, BgL_envz00_bglt);
static obj_t BGl_compilezd2tailzd2sequence3036z00zzjvm_tailz00(obj_t, obj_t, obj_t);
static obj_t BGl_libraryzd2moduleszd2initz00zzjvm_tailz00();
static obj_t BGl_compilezd2tailzd2default3025z00zzjvm_tailz00(BgL_nodez00_bglt, BgL_envz00_bglt);
extern obj_t BGl_vsetz12z12zzast_nodez00;
extern obj_t BGl_compilerzd2varzd2zzjvm_compilerz00(BgL_varz00_bglt, BgL_envz00_bglt);
extern obj_t BGl_setqz00zzast_nodez00;
static obj_t __cnst[ 3 ] ;


DEFINE_STATIC_PROCEDURE( BGl_compilezd2tailzd2default3025zd2envzd2zzjvm_tailz00, BgL_bgl__compileza7d2tailza7d2default3025za700za7za7jvm_tailza7003916z00, BGl__compilezd2tailzd2default3025z00zzjvm_tailz00, 0L, 2 );
extern obj_t BGl_compilezd2exprzd2envz00zzjvm_exprz00;
DEFINE_EXPORT_GENERIC( BGl_compilezd2tailzd2envz00zzjvm_tailz00, BgL_bgl__compileza7d2tail3726za7d2za7za7jvm_tailza7003917za7, BGl__compilezd2tail3726zd2zzjvm_tailz00, 0L, 2 );
DEFINE_STRING( BGl_string3889z00zzjvm_tailz00, BgL_bgl_string3889za700za7za7jvm_tailza7003918z00, "compile-tail-default3025 begin unspecified ", 43 );
DEFINE_STRING( BGl_string3888z00zzjvm_tailz00, BgL_bgl_string3888za700za7za7jvm_tailza7003919z00, "No method for this object", 25 );
DEFINE_STATIC_PROCEDURE( BGl_proc3861z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2atom3028za700za7za7jvm_tailza7003920z00, BGl_compilezd2tailzd2atom3028z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3862z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2var3030za700za7za7jvm_tailza7003921z00, BGl_compilezd2tailzd2var3030z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3863z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2letza7d2var3032za7d2za7za7jvm_tailza7003922za7, BGl_compilezd2tailzd2letzd2var3032zd2zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3864z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2setq3034za700za7za7jvm_tailza7003923z00, BGl_compilezd2tailzd2setq3034z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3865z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2sequence3036za700za7za7jvm_tailza7003924z00, BGl_compilezd2tailzd2sequence3036z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3866z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2conditional3038za700za7za7jvm_tailza7003925z00, BGl_compilezd2tailzd2conditional3038z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3867z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2select3040za700za7za7jvm_tailza7003926z00, BGl_compilezd2tailzd2select3040z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3868z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2letza7d2fun3042za7d2za7za7jvm_tailza7003927za7, BGl_compilezd2tailzd2letzd2fun3042zd2zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3870z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2appza7d2ly3046za7d2za7za7jvm_tailza7003928za7, BGl_compilezd2tailzd2appzd2ly3046zd2zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3869z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2app3044za700za7za7jvm_tailza7003929z00, BGl_compilezd2tailzd2app3044z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3871z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2funcall3048za700za7za7jvm_tailza7003930z00, BGl_compilezd2tailzd2funcall3048z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3872z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2pragma3050za700za7za7jvm_tailza7003931z00, BGl_compilezd2tailzd2pragma3050z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3873z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2getfield3052za700za7za7jvm_tailza7003932z00, BGl_compilezd2tailzd2getfield3052z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3874z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2setfield3054za700za7za7jvm_tailza7003933z00, BGl_compilezd2tailzd2setfield3054z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3875z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2new3056za700za7za7jvm_tailza7003934z00, BGl_compilezd2tailzd2new3056z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3876z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2valloc3058za700za7za7jvm_tailza7003935z00, BGl_compilezd2tailzd2valloc3058z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3877z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2vref3060za700za7za7jvm_tailza7003936z00, BGl_compilezd2tailzd2vref3060z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3878z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2vsetza7123062za712za7za7jvm_tailza7003937za7, BGl_compilezd2tailzd2vsetz123062z12zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3880z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2isa3066za700za7za7jvm_tailza7003938z00, BGl_compilezd2tailzd2isa3066z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3879z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2vlength3064za700za7za7jvm_tailza7003939z00, BGl_compilezd2tailzd2vlength3064z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3881z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2cast3068za700za7za7jvm_tailza7003940z00, BGl_compilezd2tailzd2cast3068z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3882z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2setza7d2exza7d2it3070za700za7za7jvm_tailza7003941z00, BGl_compilezd2tailzd2setzd2exzd2it3070z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3883z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2jumpza7d2exza7d2it3072za700za7za7jvm_tailza7003942z00, BGl_compilezd2tailzd2jumpzd2exzd2it3072z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3884z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2fail3074za700za7za7jvm_tailza7003943z00, BGl_compilezd2tailzd2fail3074z00zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3885z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2makeza7d2box3076za7d2za7za7jvm_tailza7003944za7, BGl_compilezd2tailzd2makezd2box3076zd2zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3886z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2boxza7d2ref3078za7d2za7za7jvm_tailza7003945za7, BGl_compilezd2tailzd2boxzd2ref3078zd2zzjvm_tailz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3887z00zzjvm_tailz00, BgL_bgl_compileza7d2tailza7d2boxza7d2setza7123080za7c0za7za7jvm_tailza7003946z00, BGl_compilezd2tailzd2boxzd2setz123080zc0zzjvm_tailz00, 0L, 2 );



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzjvm_tailz00(long BgL_checksumz00_1624, char * BgL_fromz00_1625)
{ AN_OBJECT;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zzjvm_tailz00))
{ 
BGl_requirezd2initializa7ationz75zzjvm_tailz00 = 
BBOOL(((bool_t)0)); 
BGl_libraryzd2moduleszd2initz00zzjvm_tailz00(); 
BGl_cnstzd2initzd2zzjvm_tailz00(); 
BGl_importedzd2moduleszd2initz00zzjvm_tailz00(); 
BGl_methodzd2initzd2zzjvm_tailz00(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zzjvm_tailz00()
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 2 */
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "jvm_tail"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "jvm_tail"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "jvm_tail"); 
return BUNSPEC;} 
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zzjvm_tailz00()
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 2 */
{ /* ./Jvm/tail.scm 2 */
obj_t BgL_cportz00_1589;
BgL_cportz00_1589 = 
open_input_string(BGl_string3889z00zzjvm_tailz00); 
{ 
long BgL_iz00_1590;
BgL_iz00_1590 = ((long)2); 
BgL_loopz00_1591:
{ /* ./Jvm/tail.scm 2 */
bool_t BgL_test3891z00_1592;
BgL_test3891z00_1592 = 
(BgL_iz00_1590==((long)-1)); 
if(BgL_test3891z00_1592)
{ /* ./Jvm/tail.scm 2 */
return BUNSPEC;}  else 
{ /* ./Jvm/tail.scm 2 */
{ /* ./Jvm/tail.scm 2 */
obj_t BgL_arg3893z00_1593;
{ /* ./Jvm/tail.scm 2 */
obj_t BgL_list3896z00_1594;
BgL_list3896z00_1594 = 
MAKE_PAIR(BgL_cportz00_1589, BNIL); 
BgL_arg3893z00_1593 = 
BGl_readz00zz__readerz00(BgL_list3896z00_1594); } 
{ /* ./Jvm/tail.scm 2 */
int BgL_auxz00_1641;
BgL_auxz00_1641 = 
(int)(BgL_iz00_1590); 
CNST_TABLE_SET(BgL_auxz00_1641, BgL_arg3893z00_1593); } } 
{ /* ./Jvm/tail.scm 2 */
int BgL_auxz00_1595;
{ /* ./Jvm/tail.scm 2 */
long BgL_auxz00_1644;
BgL_auxz00_1644 = 
(BgL_iz00_1590-((long)1)); 
BgL_auxz00_1595 = 
(int)(BgL_auxz00_1644); } 
{ 
long BgL_iz00_1647;
BgL_iz00_1647 = 
(long)(BgL_auxz00_1595); 
BgL_iz00_1590 = BgL_iz00_1647; 
goto BgL_loopz00_1591;} } } } } } } 
}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zzjvm_tailz00()
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 2 */
return BUNSPEC;} 
}



/* method-init */
obj_t BGl_methodzd2initzd2zzjvm_tailz00()
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 2 */
BGl_addzd2genericz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_compilezd2tailzd2default3025zd2envzd2zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_atomz00zzast_nodez00, BGl_proc3861z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_varz00zzast_nodez00, BGl_proc3862z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_letzd2varzd2zzast_nodez00, BGl_proc3863z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_setqz00zzast_nodez00, BGl_proc3864z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_sequencez00zzast_nodez00, BGl_proc3865z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_conditionalz00zzast_nodez00, BGl_proc3866z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_selectz00zzast_nodez00, BGl_proc3867z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_letzd2funzd2zzast_nodez00, BGl_proc3868z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_appz00zzast_nodez00, BGl_proc3869z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_appzd2lyzd2zzast_nodez00, BGl_proc3870z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_funcallz00zzast_nodez00, BGl_proc3871z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_pragmaz00zzast_nodez00, BGl_proc3872z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_getfieldz00zzast_nodez00, BGl_proc3873z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_setfieldz00zzast_nodez00, BGl_proc3874z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_newz00zzast_nodez00, BGl_proc3875z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_vallocz00zzast_nodez00, BGl_proc3876z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_vrefz00zzast_nodez00, BGl_proc3877z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_vsetz12z12zzast_nodez00, BGl_proc3878z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_vlengthz00zzast_nodez00, BGl_proc3879z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_isaz00zzast_nodez00, BGl_proc3880z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_castz00zzast_nodez00, BGl_proc3881z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc3882z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc3883z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_failz00zzast_nodez00, BGl_proc3884z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_makezd2boxzd2zzast_nodez00, BGl_proc3885z00zzjvm_tailz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_boxzd2refzd2zzast_nodez00, BGl_proc3886z00zzjvm_tailz00); 
return 
BGl_addzd2methodz12zc0zz__objectz00(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc3887z00zzjvm_tailz00);} 
}



/* compile-tail-box-set!3080 */
obj_t BGl_compilezd2tailzd2boxzd2setz123080zc0zzjvm_tailz00(obj_t BgL_envz00_1505, obj_t BgL_ez00_1506, obj_t BgL_envz00_1507)
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 102 */
{ 
BgL_boxzd2setz12zc0_bglt BgL_ez00_1416;BgL_envz00_bglt BgL_envz00_1417;
BgL_ez00_1416 = 
(BgL_boxzd2setz12zc0_bglt)(BgL_ez00_1506); 
BgL_envz00_1417 = 
(BgL_envz00_bglt)(BgL_envz00_1507); 
BGl_compilerzd2boxzd2setz12z12zzjvm_compilerz00(BgL_ez00_1416, BgL_envz00_1417); 
{ /* ./Jvm/tail.scm 104 */
obj_t BgL_arg3701z00_1443;
BgL_arg3701z00_1443 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_1417, 
CNST_TABLE_REF(((long)0))); 
return 
BGl__getstaticz00zzjvm_instrz00(BgL_envz00_1417, BgL_arg3701z00_1443);} } } 
}



/* compile-tail-box-ref3078 */
obj_t BGl_compilezd2tailzd2boxzd2ref3078zd2zzjvm_tailz00(obj_t BgL_envz00_1508, obj_t BgL_ez00_1509, obj_t BgL_envz00_1510)
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 99 */
{ /* ./Jvm/tail.scm 100 */
BgL_boxzd2refzd2_bglt BgL_ez00_1596;BgL_envz00_bglt BgL_envz00_1597;
BgL_ez00_1596 = 
(BgL_boxzd2refzd2_bglt)(BgL_ez00_1509); 
BgL_envz00_1597 = 
(BgL_envz00_bglt)(BgL_envz00_1510); 
return 
BGl_compilerzd2boxzd2refz00zzjvm_compilerz00(BgL_ez00_1596, BgL_envz00_1597);} } 
}



/* compile-tail-make-box3076 */
obj_t BGl_compilezd2tailzd2makezd2box3076zd2zzjvm_tailz00(obj_t BgL_envz00_1511, obj_t BgL_ez00_1512, obj_t BgL_envz00_1513)
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 96 */
{ /* ./Jvm/tail.scm 97 */
BgL_makezd2boxzd2_bglt BgL_ez00_1598;BgL_envz00_bglt BgL_envz00_1599;
BgL_ez00_1598 = 
(BgL_makezd2boxzd2_bglt)(BgL_ez00_1512); 
BgL_envz00_1599 = 
(BgL_envz00_bglt)(BgL_envz00_1513); 
return 
BGl_compilerzd2makezd2boxz00zzjvm_compilerz00(BgL_ez00_1598, BgL_envz00_1599);} } 
}



/* compile-tail-fail3074 */
obj_t BGl_compilezd2tailzd2fail3074z00zzjvm_tailz00(obj_t BgL_envz00_1514, obj_t BgL_ez00_1515, obj_t BgL_envz00_1516)
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 93 */
{ /* ./Jvm/tail.scm 94 */
BgL_failz00_bglt BgL_ez00_1600;BgL_envz00_bglt BgL_envz00_1601;
BgL_ez00_1600 = 
(BgL_failz00_bglt)(BgL_ez00_1515); 
BgL_envz00_1601 = 
(BgL_envz00_bglt)(BgL_envz00_1516); 
return 
BGl_compilerzd2failzd2zzjvm_compilerz00(BgL_ez00_1600, BgL_envz00_1601);} } 
}



/* compile-tail-jump-ex-it3072 */
obj_t BGl_compilezd2tailzd2jumpzd2exzd2it3072z00zzjvm_tailz00(obj_t BgL_envz00_1517, obj_t BgL_ez00_1518, obj_t BgL_envz00_1519)
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 90 */
{ /* ./Jvm/tail.scm 91 */
BgL_jumpzd2exzd2itz00_bglt BgL_ez00_1602;BgL_envz00_bglt BgL_envz00_1603;
BgL_ez00_1602 = 
(BgL_jumpzd2exzd2itz00_bglt)(BgL_ez00_1518); 
BgL_envz00_1603 = 
(BgL_envz00_bglt)(BgL_envz00_1519); 
return 
BGl_compilerzd2jumpzd2exitz00zzjvm_compilerz00(BgL_ez00_1602, BgL_envz00_1603);} } 
}



/* compile-tail-set-ex-it3070 */
obj_t BGl_compilezd2tailzd2setzd2exzd2it3070z00zzjvm_tailz00(obj_t BgL_envz00_1520, obj_t BgL_ez00_1521, obj_t BgL_envz00_1522)
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 87 */
{ 
BgL_setzd2exzd2itz00_bglt BgL_ez00_1386;BgL_envz00_bglt BgL_envz00_1387;
BgL_ez00_1386 = 
(BgL_setzd2exzd2itz00_bglt)(BgL_ez00_1521); 
BgL_envz00_1387 = 
(BgL_envz00_bglt)(BgL_envz00_1522); 
return 
BGl_compilerzd2setexitzd2zzjvm_compilerz00(BgL_ez00_1386, BgL_envz00_1387, BGl_compilezd2exprzd2envz00zzjvm_exprz00);} } 
}



/* compile-tail-cast3068 */
obj_t BGl_compilezd2tailzd2cast3068z00zzjvm_tailz00(obj_t BgL_envz00_1523, obj_t BgL_ez00_1524, obj_t BgL_envz00_1525)
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 84 */
{ 
BgL_castz00_bglt BgL_ez00_1380;BgL_envz00_bglt BgL_envz00_1381;
BgL_ez00_1380 = 
(BgL_castz00_bglt)(BgL_ez00_1524); 
BgL_envz00_1381 = 
(BgL_envz00_bglt)(BgL_envz00_1525); 
return 
BGl_compilerzd2castzd2zzjvm_compilerz00(BgL_ez00_1380, BgL_envz00_1381, BGl_compilezd2tailzd2envz00zzjvm_tailz00);} } 
}



/* compile-tail-isa3066 */
obj_t BGl_compilezd2tailzd2isa3066z00zzjvm_tailz00(obj_t BgL_envz00_1526, obj_t BgL_ez00_1527, obj_t BgL_envz00_1528)
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 81 */
{ /* ./Jvm/tail.scm 82 */
BgL_isaz00_bglt BgL_ez00_1604;BgL_envz00_bglt BgL_envz00_1605;
BgL_ez00_1604 = 
(BgL_isaz00_bglt)(BgL_ez00_1527); 
BgL_envz00_1605 = 
(BgL_envz00_bglt)(BgL_envz00_1528); 
return 
BGl_compilerzd2isazd2zzjvm_compilerz00(BgL_ez00_1604, BgL_envz00_1605);} } 
}



/* compile-tail-vlength3064 */
obj_t BGl_compilezd2tailzd2vlength3064z00zzjvm_tailz00(obj_t BgL_envz00_1529, obj_t BgL_ez00_1530, obj_t BgL_envz00_1531)
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 78 */
{ /* ./Jvm/tail.scm 79 */
BgL_vlengthz00_bglt BgL_ez00_1606;BgL_envz00_bglt BgL_envz00_1607;
BgL_ez00_1606 = 
(BgL_vlengthz00_bglt)(BgL_ez00_1530); 
BgL_envz00_1607 = 
(BgL_envz00_bglt)(BgL_envz00_1531); 
return 
BGl_compilerzd2vlengthzd2zzjvm_compilerz00(BgL_ez00_1606, BgL_envz00_1607);} } 
}



/* compile-tail-vset!3062 */
obj_t BGl_compilezd2tailzd2vsetz123062z12zzjvm_tailz00(obj_t BgL_envz00_1532, obj_t BgL_ez00_1533, obj_t BgL_envz00_1534)
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 74 */
{ 
BgL_vsetz12z12_bglt BgL_ez00_1361;BgL_envz00_bglt BgL_envz00_1362;
BgL_ez00_1361 = 
(BgL_vsetz12z12_bglt)(BgL_ez00_1533); 
BgL_envz00_1362 = 
(BgL_envz00_bglt)(BgL_envz00_1534); 
BGl_compilerzd2vsetzd2zzjvm_compilerz00(BgL_ez00_1361, BgL_envz00_1362); 
{ /* ./Jvm/tail.scm 76 */
obj_t BgL_arg3634z00_1442;
BgL_arg3634z00_1442 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_1362, 
CNST_TABLE_REF(((long)0))); 
return 
BGl__getstaticz00zzjvm_instrz00(BgL_envz00_1362, BgL_arg3634z00_1442);} } } 
}



/* compile-tail-vref3060 */
obj_t BGl_compilezd2tailzd2vref3060z00zzjvm_tailz00(obj_t BgL_envz00_1535, obj_t BgL_ez00_1536, obj_t BgL_envz00_1537)
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 71 */
{ /* ./Jvm/tail.scm 72 */
BgL_vrefz00_bglt BgL_ez00_1608;BgL_envz00_bglt BgL_envz00_1609;
BgL_ez00_1608 = 
(BgL_vrefz00_bglt)(BgL_ez00_1536); 
BgL_envz00_1609 = 
(BgL_envz00_bglt)(BgL_envz00_1537); 
return 
BGl_compilerzd2vrefzd2zzjvm_compilerz00(BgL_ez00_1608, BgL_envz00_1609);} } 
}



/* compile-tail-valloc3058 */
obj_t BGl_compilezd2tailzd2valloc3058z00zzjvm_tailz00(obj_t BgL_envz00_1538, obj_t BgL_ez00_1539, obj_t BgL_envz00_1540)
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 68 */
{ /* ./Jvm/tail.scm 69 */
BgL_vallocz00_bglt BgL_ez00_1610;BgL_envz00_bglt BgL_envz00_1611;
BgL_ez00_1610 = 
(BgL_vallocz00_bglt)(BgL_ez00_1539); 
BgL_envz00_1611 = 
(BgL_envz00_bglt)(BgL_envz00_1540); 
return 
BGl_compilerzd2valloczd2zzjvm_compilerz00(BgL_ez00_1610, BgL_envz00_1611);} } 
}



/* compile-tail-new3056 */
obj_t BGl_compilezd2tailzd2new3056z00zzjvm_tailz00(obj_t BgL_envz00_1541, obj_t BgL_ez00_1542, obj_t BgL_envz00_1543)
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 65 */
{ /* ./Jvm/tail.scm 66 */
BgL_newz00_bglt BgL_ez00_1612;BgL_envz00_bglt BgL_envz00_1613;
BgL_ez00_1612 = 
(BgL_newz00_bglt)(BgL_ez00_1542); 
BgL_envz00_1613 = 
(BgL_envz00_bglt)(BgL_envz00_1543); 
return 
BGl_compilerzd2newzd2zzjvm_compilerz00(BgL_ez00_1612, BgL_envz00_1613);} } 
}



/* compile-tail-setfield3054 */
obj_t BGl_compilezd2tailzd2setfield3054z00zzjvm_tailz00(obj_t BgL_envz00_1544, obj_t BgL_ez00_1545, obj_t BgL_envz00_1546)
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 61 */
{ 
BgL_setfieldz00_bglt BgL_ez00_1336;BgL_envz00_bglt BgL_envz00_1337;
BgL_ez00_1336 = 
(BgL_setfieldz00_bglt)(BgL_ez00_1545); 
BgL_envz00_1337 = 
(BgL_envz00_bglt)(BgL_envz00_1546); 
BGl_compilerzd2setfieldzd2zzjvm_compilerz00(BgL_ez00_1336, BgL_envz00_1337); 
{ /* ./Jvm/tail.scm 63 */
obj_t BgL_arg3602z00_1441;
BgL_arg3602z00_1441 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_1337, 
CNST_TABLE_REF(((long)0))); 
return 
BGl__getstaticz00zzjvm_instrz00(BgL_envz00_1337, BgL_arg3602z00_1441);} } } 
}



/* compile-tail-getfield3052 */
obj_t BGl_compilezd2tailzd2getfield3052z00zzjvm_tailz00(obj_t BgL_envz00_1547, obj_t BgL_ez00_1548, obj_t BgL_envz00_1549)
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 58 */
{ /* ./Jvm/tail.scm 59 */
BgL_getfieldz00_bglt BgL_ez00_1614;BgL_envz00_bglt BgL_envz00_1615;
BgL_ez00_1614 = 
(BgL_getfieldz00_bglt)(BgL_ez00_1548); 
BgL_envz00_1615 = 
(BgL_envz00_bglt)(BgL_envz00_1549); 
return 
BGl_compilerzd2getfieldzd2zzjvm_compilerz00(BgL_ez00_1614, BgL_envz00_1615);} } 
}



/* compile-tail-pragma3050 */
obj_t BGl_compilezd2tailzd2pragma3050z00zzjvm_tailz00(obj_t BgL_envz00_1550, obj_t BgL_ez00_1551, obj_t BgL_envz00_1552)
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 55 */
{ /* ./Jvm/tail.scm 56 */
BgL_pragmaz00_bglt BgL_ez00_1616;BgL_envz00_bglt BgL_envz00_1617;
BgL_ez00_1616 = 
(BgL_pragmaz00_bglt)(BgL_ez00_1551); 
BgL_envz00_1617 = 
(BgL_envz00_bglt)(BgL_envz00_1552); 
return 
BGl_compilerzd2pragmazd2zzjvm_compilerz00(BgL_ez00_1616, BgL_envz00_1617);} } 
}



/* compile-tail-funcall3048 */
obj_t BGl_compilezd2tailzd2funcall3048z00zzjvm_tailz00(obj_t BgL_envz00_1553, obj_t BgL_ez00_1554, obj_t BgL_envz00_1555)
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 52 */
{ /* ./Jvm/tail.scm 53 */
BgL_funcallz00_bglt BgL_ez00_1618;BgL_envz00_bglt BgL_envz00_1619;
BgL_ez00_1618 = 
(BgL_funcallz00_bglt)(BgL_ez00_1554); 
BgL_envz00_1619 = 
(BgL_envz00_bglt)(BgL_envz00_1555); 
return 
BGl_compilerzd2funcallzd2zzjvm_compilerz00(BgL_ez00_1618, BgL_envz00_1619);} } 
}



/* compile-tail-app-ly3046 */
obj_t BGl_compilezd2tailzd2appzd2ly3046zd2zzjvm_tailz00(obj_t BgL_envz00_1556, obj_t BgL_ez00_1557, obj_t BgL_envz00_1558)
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 49 */
{ /* ./Jvm/tail.scm 50 */
BgL_appzd2lyzd2_bglt BgL_ez00_1620;BgL_envz00_bglt BgL_envz00_1621;
BgL_ez00_1620 = 
(BgL_appzd2lyzd2_bglt)(BgL_ez00_1557); 
BgL_envz00_1621 = 
(BgL_envz00_bglt)(BgL_envz00_1558); 
return 
BGl_compilerzd2applyzd2zzjvm_compilerz00(BgL_ez00_1620, BgL_envz00_1621);} } 
}



/* compile-tail-app3044 */
obj_t BGl_compilezd2tailzd2app3044z00zzjvm_tailz00(obj_t BgL_envz00_1559, obj_t BgL_ez00_1560, obj_t BgL_envz00_1561)
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 35 */
{ 
BgL_appz00_bglt BgL_ez00_1282;BgL_envz00_bglt BgL_envz00_1283;
BgL_ez00_1282 = 
(BgL_appz00_bglt)(BgL_ez00_1560); 
BgL_envz00_1283 = 
(BgL_envz00_bglt)(BgL_envz00_1561); 
{ /* ./Jvm/tail.scm 37 */
BgL_variablez00_bglt BgL_vz00_1287;
{ /* ./Jvm/tail.scm 37 */
BgL_varz00_bglt BgL_arg3563z00_1309;
BgL_arg3563z00_1309 = 
(((BgL_appz00_bglt)CREF(BgL_ez00_1282))->BgL_funz00); 
BgL_vz00_1287 = 
(((BgL_varz00_bglt)CREF(BgL_arg3563z00_1309))->BgL_variablez00); } 
{ /* ./Jvm/tail.scm 38 */
bool_t BgL_test3510z00_1288;
{ /* ./Jvm/tail.scm 38 */
obj_t BgL_auxz00_1744;obj_t BgL_auxz00_1742;
BgL_auxz00_1744 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_1283))->BgL_currentzd2methodzd2); 
BgL_auxz00_1742 = 
(obj_t)(BgL_vz00_1287); 
BgL_test3510z00_1288 = 
(BgL_auxz00_1742==BgL_auxz00_1744); } 
if(BgL_test3510z00_1288)
{ /* ./Jvm/tail.scm 39 */
obj_t BgL_paramsz00_1289;
{ /* ./Jvm/tail.scm 39 */
BgL_sfunz00_bglt BgL_obj1367z00_1429;
{ /* ./Jvm/tail.scm 39 */
BgL_valuez00_bglt BgL_auxz00_1748;
BgL_auxz00_1748 = 
(((BgL_variablez00_bglt)CREF(BgL_vz00_1287))->BgL_valuez00); 
BgL_obj1367z00_1429 = 
(BgL_sfunz00_bglt)(BgL_auxz00_1748); } 
BgL_paramsz00_1289 = 
(((BgL_sfunz00_bglt)CREF(BgL_obj1367z00_1429))->BgL_argsz00); } 
{ 
obj_t BgL_l3021z00_1290;
{ /* ./Jvm/tail.scm 40 */
obj_t BgL_arg3512z00_1292;
BgL_arg3512z00_1292 = 
(((BgL_appz00_bglt)CREF(BgL_ez00_1282))->BgL_argsz00); 
BgL_l3021z00_1290 = BgL_arg3512z00_1292; 
BgL_forzd2each3022zd2_1291:
{ /* ./Jvm/tail.scm 40 */
bool_t BgL_test3515z00_1293;
BgL_test3515z00_1293 = 
PAIRP(BgL_l3021z00_1290); 
if(BgL_test3515z00_1293)
{ /* ./Jvm/tail.scm 40 */
{ /* ./Jvm/tail.scm 40 */
obj_t BgL_ez00_1294;
BgL_ez00_1294 = 
CAR(BgL_l3021z00_1290); 
BGl_compilezd2exprzd2zzjvm_exprz00(
(BgL_nodez00_bglt)(BgL_ez00_1294), BgL_envz00_1283); } 
{ /* ./Jvm/tail.scm 40 */
obj_t BgL_arg3520z00_1295;
BgL_arg3520z00_1295 = 
CDR(BgL_l3021z00_1290); 
{ 
obj_t BgL_l3021z00_1759;
BgL_l3021z00_1759 = BgL_arg3520z00_1295; 
BgL_l3021z00_1290 = BgL_l3021z00_1759; 
goto BgL_forzd2each3022zd2_1291;} } }  else 
{ /* ./Jvm/tail.scm 40 */((bool_t)1); } } } } 
{ 
obj_t BgL_l3023z00_1296;
{ /* ./Jvm/tail.scm 41 */
obj_t BgL_arg3525z00_1298;
BgL_arg3525z00_1298 = 
bgl_reverse(BgL_paramsz00_1289); 
BgL_l3023z00_1296 = BgL_arg3525z00_1298; 
BgL_forzd2each3024zd2_1297:
{ /* ./Jvm/tail.scm 41 */
bool_t BgL_test3528z00_1299;
BgL_test3528z00_1299 = 
PAIRP(BgL_l3023z00_1296); 
if(BgL_test3528z00_1299)
{ /* ./Jvm/tail.scm 41 */
{ /* ./Jvm/tail.scm 41 */
obj_t BgL_pz00_1300;
BgL_pz00_1300 = 
CAR(BgL_l3023z00_1296); 
BGl__storez00zzjvm_instrz00(BgL_envz00_1283, 
(BgL_localz00_bglt)(BgL_pz00_1300)); } 
{ /* ./Jvm/tail.scm 41 */
obj_t BgL_arg3532z00_1301;
BgL_arg3532z00_1301 = 
CDR(BgL_l3023z00_1296); 
{ 
obj_t BgL_l3023z00_1767;
BgL_l3023z00_1767 = BgL_arg3532z00_1301; 
BgL_l3023z00_1296 = BgL_l3023z00_1767; 
goto BgL_forzd2each3024zd2_1297;} } }  else 
{ /* ./Jvm/tail.scm 41 */((bool_t)1); } } } } 
{ /* ./Jvm/tail.scm 44 */
obj_t BgL_arg3537z00_1302;
{ /* ./Jvm/tail.scm 44 */
obj_t BgL_arg3541z00_1303;obj_t BgL_arg3542z00_1304;
{ /* ./Jvm/tail.scm 44 */
obj_t BgL_arg3545z00_1305;
{ /* ./Jvm/tail.scm 44 */
BgL_typez00_bglt BgL_arg3548z00_1306;
BgL_arg3548z00_1306 = 
(((BgL_variablez00_bglt)CREF(BgL_vz00_1287))->BgL_typez00); 
BgL_arg3545z00_1305 = 
BGl_compilezd2typezd2zzjvm_envz00(
(obj_t)(BgL_arg3548z00_1306), BgL_envz00_1283); } 
BgL_arg3541z00_1303 = 
BGl_simplezd2typezd2zzjvm_instrz00(BgL_arg3545z00_1305); } 
BgL_arg3542z00_1304 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_1283))->BgL_stackz00); 
BgL_arg3537z00_1302 = 
MAKE_PAIR(BgL_arg3541z00_1303, BgL_arg3542z00_1304); } 
{ /* ./Jvm/tail.scm 42 */
BgL_envz00_bglt BgL_obj2960z00_1439;obj_t BgL_val2959z00_1440;
BgL_obj2960z00_1439 = BgL_envz00_1283; 
BgL_val2959z00_1440 = BgL_arg3537z00_1302; 
((((BgL_envz00_bglt)CREF(BgL_obj2960z00_1439))->BgL_stackz00) = ((obj_t)BgL_val2959z00_1440), BUNSPEC); } } 
return 
BGl__gotoz00zzjvm_instrz00(BgL_envz00_1283, 
CNST_TABLE_REF(((long)1)));}  else 
{ /* ./Jvm/tail.scm 38 */
return 
BGl_compilerzd2appzd2zzjvm_compilerz00(BgL_ez00_1282, BgL_envz00_1283);} } } } } 
}



/* compile-tail-let-fun3042 */
obj_t BGl_compilezd2tailzd2letzd2fun3042zd2zzjvm_tailz00(obj_t BgL_envz00_1562, obj_t BgL_ez00_1563, obj_t BgL_envz00_1564)
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 32 */
{ 
BgL_letzd2funzd2_bglt BgL_ez00_1276;BgL_envz00_bglt BgL_envz00_1277;
BgL_ez00_1276 = 
(BgL_letzd2funzd2_bglt)(BgL_ez00_1563); 
BgL_envz00_1277 = 
(BgL_envz00_bglt)(BgL_envz00_1564); 
return 
BGl_compilerzd2labelszd2zzjvm_compilerz00(BgL_ez00_1276, BgL_envz00_1277, BGl_compilezd2tailzd2envz00zzjvm_tailz00);} } 
}



/* compile-tail-select3040 */
obj_t BGl_compilezd2tailzd2select3040z00zzjvm_tailz00(obj_t BgL_envz00_1565, obj_t BgL_ez00_1566, obj_t BgL_envz00_1567)
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 29 */
{ 
BgL_selectz00_bglt BgL_ez00_1270;BgL_envz00_bglt BgL_envz00_1271;
BgL_ez00_1270 = 
(BgL_selectz00_bglt)(BgL_ez00_1566); 
BgL_envz00_1271 = 
(BgL_envz00_bglt)(BgL_envz00_1567); 
return 
BGl_compilerzd2selectzd2zzjvm_compilerz00(BgL_ez00_1270, BgL_envz00_1271, BGl_compilezd2tailzd2envz00zzjvm_tailz00);} } 
}



/* compile-tail-conditional3038 */
obj_t BGl_compilezd2tailzd2conditional3038z00zzjvm_tailz00(obj_t BgL_envz00_1568, obj_t BgL_ez00_1569, obj_t BgL_envz00_1570)
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 26 */
{ 
BgL_conditionalz00_bglt BgL_ez00_1264;BgL_envz00_bglt BgL_envz00_1265;
BgL_ez00_1264 = 
(BgL_conditionalz00_bglt)(BgL_ez00_1569); 
BgL_envz00_1265 = 
(BgL_envz00_bglt)(BgL_envz00_1570); 
return 
BGl_compilerzd2ifzd2zzjvm_compilerz00(BgL_ez00_1264, BgL_envz00_1265, BGl_compilezd2tailzd2envz00zzjvm_tailz00);} } 
}



/* compile-tail-sequence3036 */
obj_t BGl_compilezd2tailzd2sequence3036z00zzjvm_tailz00(obj_t BgL_envz00_1571, obj_t BgL_ez00_1572, obj_t BgL_envz00_1573)
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 23 */
{ 
BgL_sequencez00_bglt BgL_ez00_1258;BgL_envz00_bglt BgL_envz00_1259;
BgL_ez00_1258 = 
(BgL_sequencez00_bglt)(BgL_ez00_1572); 
BgL_envz00_1259 = 
(BgL_envz00_bglt)(BgL_envz00_1573); 
return 
BGl_compilerzd2sequencezd2zzjvm_compilerz00(BgL_ez00_1258, BgL_envz00_1259, BGl_compilezd2tailzd2envz00zzjvm_tailz00);} } 
}



/* compile-tail-setq3034 */
obj_t BGl_compilezd2tailzd2setq3034z00zzjvm_tailz00(obj_t BgL_envz00_1574, obj_t BgL_ez00_1575, obj_t BgL_envz00_1576)
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 19 */
{ 
BgL_setqz00_bglt BgL_ez00_1251;BgL_envz00_bglt BgL_envz00_1252;
BgL_ez00_1251 = 
(BgL_setqz00_bglt)(BgL_ez00_1575); 
BgL_envz00_1252 = 
(BgL_envz00_bglt)(BgL_envz00_1576); 
BGl_compilerzd2setqzd2zzjvm_compilerz00(BgL_ez00_1251, BgL_envz00_1252); 
{ /* ./Jvm/tail.scm 21 */
obj_t BgL_arg3473z00_1424;
BgL_arg3473z00_1424 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_1252, 
CNST_TABLE_REF(((long)0))); 
return 
BGl__getstaticz00zzjvm_instrz00(BgL_envz00_1252, BgL_arg3473z00_1424);} } } 
}



/* compile-tail-let-var3032 */
obj_t BGl_compilezd2tailzd2letzd2var3032zd2zzjvm_tailz00(obj_t BgL_envz00_1577, obj_t BgL_ez00_1578, obj_t BgL_envz00_1579)
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 16 */
{ 
BgL_letzd2varzd2_bglt BgL_ez00_1245;BgL_envz00_bglt BgL_envz00_1246;
BgL_ez00_1245 = 
(BgL_letzd2varzd2_bglt)(BgL_ez00_1578); 
BgL_envz00_1246 = 
(BgL_envz00_bglt)(BgL_envz00_1579); 
return 
BGl_compilerzd2letzd2zzjvm_compilerz00(BgL_ez00_1245, BgL_envz00_1246, BGl_compilezd2tailzd2envz00zzjvm_tailz00);} } 
}



/* compile-tail-var3030 */
obj_t BGl_compilezd2tailzd2var3030z00zzjvm_tailz00(obj_t BgL_envz00_1580, obj_t BgL_ez00_1581, obj_t BgL_envz00_1582)
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 13 */
{ /* ./Jvm/tail.scm 14 */
BgL_varz00_bglt BgL_ez00_1622;BgL_envz00_bglt BgL_envz00_1623;
BgL_ez00_1622 = 
(BgL_varz00_bglt)(BgL_ez00_1581); 
BgL_envz00_1623 = 
(BgL_envz00_bglt)(BgL_envz00_1582); 
return 
BGl_compilerzd2varzd2zzjvm_compilerz00(BgL_ez00_1622, BgL_envz00_1623);} } 
}



/* compile-tail-atom3028 */
obj_t BGl_compilezd2tailzd2atom3028z00zzjvm_tailz00(obj_t BgL_envz00_1583, obj_t BgL_ez00_1584, obj_t BgL_envz00_1585)
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 10 */
{ 
BgL_atomz00_bglt BgL_ez00_1233;BgL_envz00_bglt BgL_envz00_1234;
BgL_ez00_1233 = 
(BgL_atomz00_bglt)(BgL_ez00_1584); 
BgL_envz00_1234 = 
(BgL_envz00_bglt)(BgL_envz00_1585); 
return 
BGl_compilerzd2atomzd2zzjvm_compilerz00(
(obj_t)(BgL_ez00_1233), BgL_envz00_1234);} } 
}



/* compile-tail */
BGL_EXPORTED_DEF obj_t BGl_compilezd2tailzd2zzjvm_tailz00(BgL_nodez00_bglt BgL_ez00_1, BgL_envz00_bglt BgL_envz00_2)
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 8 */
{ /* ./Jvm/tail.scm 8 */
obj_t BgL_method3026z00_1444;
{ /* ./Jvm/tail.scm 8 */
BgL_objectz00_bglt BgL_objz00_1445;
BgL_objz00_1445 = 
(BgL_objectz00_bglt)(BgL_ez00_1); 
{ /* ./Jvm/tail.scm 8 */
long BgL_objzd2classzd2numz00_1446;
BgL_objzd2classzd2numz00_1446 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_1445); 
{ /* ./Jvm/tail.scm 8 */
obj_t BgL_arg2017z00_1447;
{ /* ./Jvm/tail.scm 8 */
int BgL_auxz00_1810;
BgL_auxz00_1810 = 
(int)(((long)1)); 
BgL_arg2017z00_1447 = 
PROCEDURE_REF(BGl_compilezd2tailzd2envz00zzjvm_tailz00, BgL_auxz00_1810); } 
{ /* ./Jvm/tail.scm 8 */
int BgL_offsetz00_1450;
BgL_offsetz00_1450 = 
(int)(BgL_objzd2classzd2numz00_1446); 
{ /* ./Jvm/tail.scm 8 */
long BgL_offsetz00_1451;
{ /* ./Jvm/tail.scm 8 */
long BgL_auxz00_1814;
BgL_auxz00_1814 = 
(long)(BgL_offsetz00_1450); 
BgL_offsetz00_1451 = 
(BgL_auxz00_1814-OBJECT_TYPE); } 
{ /* ./Jvm/tail.scm 8 */
long BgL_modz00_1452;
{ /* ./Jvm/tail.scm 8 */
int BgL_arg2028z00_1453;
BgL_arg2028z00_1453 = 
(int)(((long)8)); 
{ /* ./Jvm/tail.scm 8 */
long BgL_n2z00_1461;
BgL_n2z00_1461 = 
(long)(BgL_arg2028z00_1453); 
BgL_modz00_1452 = 
(BgL_offsetz00_1451/BgL_n2z00_1461); } } 
{ /* ./Jvm/tail.scm 8 */
long BgL_restz00_1454;
{ /* ./Jvm/tail.scm 8 */
int BgL_arg2024z00_1455;
BgL_arg2024z00_1455 = 
(int)(((long)8)); 
{ /* ./Jvm/tail.scm 8 */
long BgL_n2z00_1464;
BgL_n2z00_1464 = 
(long)(BgL_arg2024z00_1455); 
BgL_restz00_1454 = 
(BgL_offsetz00_1451%BgL_n2z00_1464); } } 
{ /* ./Jvm/tail.scm 8 */

{ /* ./Jvm/tail.scm 8 */
obj_t BgL_bucketz00_1456;
{ /* ./Jvm/tail.scm 8 */
int BgL_kz00_1466;
BgL_kz00_1466 = 
(int)(BgL_modz00_1452); 
BgL_bucketz00_1456 = 
VECTOR_REF(BgL_arg2017z00_1447,BgL_kz00_1466); } 
{ /* ./Jvm/tail.scm 8 */
int BgL_kz00_1468;
BgL_kz00_1468 = 
(int)(BgL_restz00_1454); 
BgL_method3026z00_1444 = 
VECTOR_REF(BgL_bucketz00_1456,BgL_kz00_1468); } } } } } } } } } } 
return 
PROCEDURE_ENTRY(BgL_method3026z00_1444)(BgL_method3026z00_1444, 
(obj_t)(BgL_ez00_1), 
(obj_t)(BgL_envz00_2), BEOA);} } 
}



/* _compile-tail3726 */
obj_t BGl__compilezd2tail3726zd2zzjvm_tailz00(obj_t BgL_envz00_1482, obj_t BgL_ez00_1483, obj_t BgL_envz00_1484)
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 8 */
return 
BGl_compilezd2tailzd2zzjvm_tailz00(
(BgL_nodez00_bglt)(BgL_ez00_1483), 
(BgL_envz00_bglt)(BgL_envz00_1484));} 
}



/* compile-tail-default3025 */
obj_t BGl_compilezd2tailzd2default3025z00zzjvm_tailz00(BgL_nodez00_bglt BgL_ez00_3, BgL_envz00_bglt BgL_envz00_4)
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 2 */
{ /* ./Jvm/tail.scm 2 */
obj_t BgL_procz00_1469;obj_t BgL_objectz00_1471;
BgL_procz00_1469 = 
CNST_TABLE_REF(((long)2)); 
BgL_objectz00_1471 = 
(obj_t)(BgL_ez00_3); 
FAILURE(BgL_procz00_1469,BGl_string3888z00zzjvm_tailz00,BgL_objectz00_1471);} } 
}



/* _compile-tail-default3025 */
obj_t BGl__compilezd2tailzd2default3025z00zzjvm_tailz00(obj_t BgL_envz00_1586, obj_t BgL_ez00_1587, obj_t BgL_envz00_1588)
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 2 */
return 
BGl_compilezd2tailzd2default3025z00zzjvm_tailz00(
(BgL_nodez00_bglt)(BgL_ez00_1587), 
(BgL_envz00_bglt)(BgL_envz00_1588));} 
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zzjvm_tailz00()
{ AN_OBJECT;
{ /* ./Jvm/tail.scm 2 */
BGl_modulezd2initializa7ationz75zztype_typez00(((long)19090), "jvm_tail"); 
BGl_modulezd2initializa7ationz75zzast_varz00(((long)44246), "jvm_tail"); 
BGl_modulezd2initializa7ationz75zzast_nodez00(((long)50868), "jvm_tail"); 
BGl_modulezd2initializa7ationz75zzobject_classz00(((long)30791), "jvm_tail"); 
BGl_modulezd2initializa7ationz75zzjvm_envz00(((long)58889), "jvm_tail"); 
BGl_modulezd2initializa7ationz75zzjvm_instrz00(((long)18045), "jvm_tail"); 
BGl_modulezd2initializa7ationz75zzjvm_exprz00(((long)25872), "jvm_tail"); 
return 
BGl_modulezd2initializa7ationz75zzjvm_compilerz00(((long)61602), "jvm_tail");} 
}

